package com.steerinfo.meterwork.meterworkrailwaymotorialreceived.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkrailwaymotorialreceived.model.MeterWorkRailwayMotorialReceived;
import com.steerinfo.meterwork.meterworkrailwaymotorialreceived.service.IMeterWorkRailwayMotorialReceivedService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkRailwayMotorialReceived RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-12-22 03:55
 * 类描述
 * 修订历史：
 * 日期：2020-12-22
 * 作者：generator
 * 参考：
 * 描述：MeterWorkRailwayMotorialReceived RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkrailwayMotorialreceiveds")
public class MeterWorkRailwayMotorialReceivedController extends BaseRESTfulController {

    @Autowired
    IMeterWorkRailwayMotorialReceivedService meterWorkRailwayMotorialReceivedService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwaymotorialreceived:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkRailwayMotorialReceived> list = meterWorkRailwayMotorialReceivedService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwaymotorialreceived:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkRailwayMotorialReceived> list = meterWorkRailwayMotorialReceivedService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkRailwayMotorialReceived对象创建")
    @ApiImplicitParam(name = "meterworkrailwayreceiveds", value = "详细实体meterWorkRailwayMotorialReceived", required = true, dataType = "MeterWorkRailwayMotorialReceived")
    //@RequiresPermissions("meterworkrailwaymotorialreceived:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkRailwayMotorialReceived model) {
        try {
            MeterWorkRailwayMotorialReceived meterWorkRailwayMotorialReceived = meterWorkRailwayMotorialReceivedService.add(model);
            return success(meterWorkRailwayMotorialReceived);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwaymotorialreceived:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkRailwayMotorialReceived meterWorkRailwayMotorialReceived = meterWorkRailwayMotorialReceivedService.getById(id);
            return success(meterWorkRailwayMotorialReceived);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkRailwayMotorialReceived信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterworkrailwayreceiveds", value = "详细实体meterWorkRailwayMotorialReceived", required = true, dataType = "MeterWorkRailwayMotorialReceived")
    })
    //@RequiresPermissions("meterworkrailwaymotorialreceived:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkRailwayMotorialReceived model) {
        try {
            model.setId(id);
            MeterWorkRailwayMotorialReceived meterWorkRailwayMotorialReceived = meterWorkRailwayMotorialReceivedService.modify(model);
            return success(meterWorkRailwayMotorialReceived);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwaymotorialreceived:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkRailwayMotorialReceivedService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwaymotorialreceived:view")
    @GetMapping(value = "/doQueryWf")
    public RESTfulResult doQueryWf(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            List<MeterWorkRailwayMotorialReceived> list = meterWorkRailwayMotorialReceivedService.doQueryWf(parmas);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
